# -*- coding: utf-8 -*-
# MIT License
# Copyright (c) 2020 Arthur
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.


class DBLStatsException(Exception):
    """The base class for all dblstats exceptions."""
    pass


class UnknownException(DBLStatsException):
    """
    Gets raised when the developer didn't anticipate for something.
    If this gets raised, please report this to our github:
    https://github.com/Arthurdw/dblstats/issues
    """
    pass


class InvalidAuthorizationToken(DBLStatsException):
    """The exception that get raised when no or an invalid client token has been provided."""
    pass


class InvalidTarget(DBLStatsException):
    """The exception that get raised when the requested target does not exist."""
    pass


class InvalidProperty(DBLStatsException):
    """The exception that gets raised when a property of the right type has been provided but is not allowed in that
    method or class"""
    pass
